=== debian/changelog ===
miniz (3.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1124745)
  * New upstream version 3.1.0
  * d/{patches,tests}: enable autopkgtests

 -- Andreas Glinserer <andreas.glinserer@canonical.com>  Tue, 06 Jan 2026 11:20:09 +0100
