=== debian/control ===
Source: miniz
Section: libdevel
Priority: optional
Maintainer: Andreas Glinserer <andreas.glinserer@canonical.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.7.2
Homepage: https://github.com/richgel999/miniz
#Vcs-Browser: https://salsa.debian.org/debian/miniz
#Vcs-Git: https://salsa.debian.org/debian/miniz.git
Description: Miniz is a lossless data compression library
 Miniz is a lossless, high performance data compression library in a single
 source file that implements the zlib (RFC 1950) and Deflate (RFC 1951)
 compressed data format specification standards. It supports the most commonly
 used functions exported by the zlib library, but is a completely independent
 implementation so zlib's licensing requirements do not apply. Miniz also
 contains simple to use functions for writing .PNG format image files and
 reading/writing/appending .ZIP format archives. Miniz's compression speed has
 been tuned to be comparable to zlib's, and it also has a specialized real-time
 compressor function designed to compare well against fastlz/minilzo.

Package: libminiz3
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Miniz is a lossless data compression library
 ${source:Extended-Description}

Package: libminiz-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libminiz3 (= ${binary:Version}),
Description: Miniz development files
 ${source:Extended-Description}
