=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DBUILD_EXAMPLES=Yes \
	-DBUILD_SHARED_LIBS=Yes \
	-DBUILD_TESTS=Yes
