=== debian/tests/control ===
Tests: miniz-test
Depends: @, build-essential, pkgconf
Restrictions: allow-stderr, needs-internet
