=== debian/watch ===
Version: 5

Template: Github
Owner: richgel999
Project: miniz
